<template>
  <div
    id="resourcecontentview"
    @dragenter="dragEnter"
    @dragleave="dragLeave"
    @dragend="dragLeave"
    @dragover.prevent=""
    @drop.prevent="uploadDrop"
  >
    <!-- Drop File to Upload -->
    <div v-if="showDroppable && fileAddable" class="droppable">
      <p class="droppableText">
        {{ $t("page.resource.canDropFile") }}
      </p>
    </div>

    <!-- Headline -->
    <coscine-headline
      v-show="!isFullscreenActive"
      :headline="$t('page.resource.resources')"
    />

    <!-- Form File Window -->
    <b-form-file
      ref="fileTrigger"
      multiple
      class="mt-3"
      plain
      @update:modelValue="fileListUploadSelected"
    />

    <!-- Form File Window -->
    <b-form-file
      ref="folderTrigger"
      multiple
      class="mt-3"
      plain
      directory
      no-traverse
      @update:modelValue="fileListUploadSelected"
    />

    <!-- Files View Column -->
    <span id="filesViewSpan">
      <div
        id="filesViewCard"
        :class="isFullscreenActive == false ? 'card' : ''"
      >
        <!-- Files View -->
        <div :class="isFullscreenActive == false ? 'card-body' : ''">
          <FilesView
            ref="filesView"
            :folder-contents="folderContents"
            :is-uploading="isUploading"
            :file-list-edit="fileListEdit"
            :dir-trail="dirTrail"
            :dir-crumbs="dirCrumbs"
            @showDetail="setShowDetail"
            @folderContents="updateFolderContent"
            @fileListEdit="updateEditFileList"
            @clickFileSelect="clickFileSelect"
            @showModalDelete="showModalDelete"
            @waitingForResponse="setWaitingForResponse"
          />
        </div>
      </div>
    </span>

    <!-- Metadata Manager Column -->
    <div
      id="metadataManagerDiv"
      :class="{ hiddenMetadataManager: isMetadataManagerHidden }"
    >
      <!-- Vertical Button Bar for Fullscreen -->
      <b-button
        v-show="isFullscreenActive"
        id="metadataManagerToggleFullscreen"
        squared
        @click="toggleMetadataPanel"
      >
        <span>
          {{ $t("page.resource.metadataManager") }}
        </span>
      </b-button>

      <!-- Metadata Manager -->
      <div class="card">
        <div class="card-body">
          <MetadataManager
            :show-detail="showDetail"
            :file-list-edit="fileListEdit"
            :file-list-upload="fileListUpload"
            :folder-contents="folderContents"
            :dir-trail="dirTrail"
            :dir-crumbs="dirCrumbs"
            :is-uploading="isUploading"
            @emptyFileLists="emptyFileLists"
            @navigateTree="navigateTreeInFilesView"
            @removeElement="deleteFromUploadList"
            @removeSelection="removeSelection"
            @isUploading="setIsUploading"
            @showModalDelete="showModalDelete"
            @clickFileSelect="clickFileSelect"
            @clickFolderSelect="clickFolderSelect"
          />

          <!-- Toggle Fullscreen Button -->
          <div
            id="toggleFullscreenButton"
            :class="{ hiddenMetadataManager: !isMetadataManagerHidden }"
          >
            <button class="btn btn-secondary" @click="toggleViewMode">
              <i-bi-fullscreen-exit v-if="isFullscreenActive" />
              <i-bi-fullscreen v-else />
            </button>
          </div>
        </div>
      </div>
    </div>

    <!-- Page Loading Spinner -->
    <LoadingSpinner :is-waiting-for-response="isWaitingForResponse" />

    <!-- Delete File Modal -->
    <DeleteFolderContentsModal
      :visible="deleteModalVisible"
      :shown-files="filesToBeDeleted"
      @close="closeModalDeleteFile"
      @delete="deleteFiles"
    />
  </div>
</template>

<script lang="ts">
// import the store for current module
import useResourceStore from "../store";
// import the main store
import useMainStore from "@/store/index";
import useProjectStore from "@/modules/project/store";
import FilesView from "../components/resource-page/FilesView.vue";
import MetadataManager from "../components/resource-page/MetadataManager.vue";
import DeleteFolderContentsModal from "../components/resource-page/modals/DeleteFolderContentsModal.vue";
import { v4 as uuidv4 } from "uuid";
import { type ExtendedFile, FileUtil } from "@/modules/resource/utils/FileUtil";
import factory from "rdf-ext";
import type { BFormFile } from "bootstrap-vue-next";
import type { Dataset } from "@rdfjs/types";
import type {
  ProjectDto,
  ResourceDto,
  ResourceTypeInformationDto,
} from "@coscine/api-client/dist/types/Coscine.Api";
import type { FolderContent, FileInformation, AdaptTable } from "../types";

export default defineComponent({
  components: {
    FilesView,
    MetadataManager,
    DeleteFolderContentsModal,
  },

  beforeRouteLeave(to, from, next) {
    this.updateViewMode(false);
    next();
  },

  setup() {
    const mainStore = useMainStore();
    const projectStore = useProjectStore();
    const resourceStore = useResourceStore();

    return { mainStore, projectStore, resourceStore };
  },

  data() {
    return {
      isWaitingForResponse: false,
      showDetail: false,
      fileListEdit: [] as FolderContent[],
      fileListUpload: [] as FileInformation[],
      filesToBeDeleted: [] as FolderContent[],
      folderContents: [] as FolderContent[],
      dragCounter: 0,

      isFullscreenActive: false,
      isMetadataManagerHidden: false,
      isUploading: false,
      deleteModalVisible: false,
    };
  },

  computed: {
    resource(): null | ResourceDto {
      return this.resourceStore.currentResource;
    },
    project(): null | ProjectDto {
      return this.projectStore.currentProject;
    },
    resourceTypeInformation(): ResourceTypeInformationDto | undefined {
      return this.resourceStore.enabledResourceTypes?.find(
        (resourceType) => resourceType.id === this.resource?.type?.id,
      );
    },
    fileAddable(): boolean {
      return (
        !this.resourceTypeInformation?.resourceContent?.readOnly &&
        !this.resourceTypeInformation?.resourceContent?.metadataView
          ?.editableDataUrl &&
        !this.isGuest
      );
    },
    showDroppable(): boolean {
      return this.dragCounter > 0;
    },
    isGuest(): boolean | undefined {
      return this.projectStore.currentUserRoleIsGuest;
    },
    dirTrail(): string {
      let dirTrail = this.$route.params.dirTrail;
      if (Array.isArray(dirTrail)) {
        dirTrail = dirTrail.join("/");
      }
      return dirTrail ?? "";
    },
    dirCrumbs(): string[] {
      const trail = this.dirTrail;
      const pathArray = trail
        .substring(0, trail.lastIndexOf("/") + 1)
        .split("/")
        .filter((n) => n);

      return pathArray.map((f) => {
        return f ? `${f}/` : "";
      });
    },
  },

  watch: {
    fileListEdit() {
      if (this.fileListEdit.length > 0) {
        this.fileListUpload.length = 0;
      }
    },
    resourceTypeInformation() {
      this.emptyFileLists();
    },
  },

  mounted() {
    this.$nextTick(() => {
      window.addEventListener("resize", this.adjustViewForScreenWidth);

      this.adjustViewForScreenWidth();
    });
    this.emptyFileLists();
  },

  methods: {
    /**
     * Trigger file selection, if not editable data URL is provided.
     */
    clickFileSelect() {
      this.showDetail = false;
      // Check if editableDataUrl is present
      if (
        this.resourceTypeInformation?.resourceContent?.metadataView
          ?.editableDataUrl
      ) {
        this.emptyFileLists();
      } else {
        // Trigger a click event on fileTrigger element
        (this.$refs.fileTrigger as typeof BFormFile).element.dispatchEvent(
          new MouseEvent("click", {
            view: window,
            bubbles: true,
            cancelable: true,
          }),
        );
      }
    },

    /**
     * Trigger folder selection, if not editable data URL is provided.
     */
    clickFolderSelect() {
      this.showDetail = false;
      // Check if editableDataUrl is present
      if (
        this.resourceTypeInformation?.resourceContent?.metadataView
          ?.editableDataUrl
      ) {
        this.emptyFileLists();
      } else {
        // Trigger a click event on fileTrigger element
        (this.$refs.folderTrigger as typeof BFormFile).element.dispatchEvent(
          new MouseEvent("click", {
            view: window,
            bubbles: true,
            cancelable: true,
          }),
        );
      }
    },

    /**
     * Display the modal for file deletion and set the files to be deleted.
     * @param {FolderContent[]} files - Files to be deleted.
     */
    showModalDelete(files: FolderContent[]) {
      // Open modal
      this.deleteModalVisible = true;
      // Pass files from emit
      this.filesToBeDeleted = files;
    },

    /**
     * Close the delete modal and reset the filesToBeDeleted list.
     */
    closeModalDeleteFile() {
      this.deleteModalVisible = false;
      this.filesToBeDeleted = [];
    },

    /**
     * Trigger a navigation in the child component to update the view.
     */
    async navigateTreeInFilesView(keepEditedFiles: boolean = false) {
      await (this.$refs.filesView as unknown as typeof FilesView).navigateTree(
        keepEditedFiles,
      );
    },

    /**
     * Delete selected files.
     */
    async deleteFiles() {
      if (this.resource?.id && this.project?.id) {
        for (const fileToDelete of this.filesToBeDeleted) {
          this.$emit("waitingForResponse", true);

          await this.resourceStore.deleteBlob(
            this.project.id,
            this.resource.id,
            fileToDelete.path,
          );

          if (this.fileListEdit.includes(fileToDelete)) {
            this.fileListEdit.splice(
              this.fileListEdit.indexOf(fileToDelete),
              1,
            );
          }
        }
        this.closeModalDeleteFile();
        // Trigger a navigation in the child component to update the view after deletion
        await this.navigateTreeInFilesView(true);
        this.$emit("waitingForResponse", false);
      }
    },

    /**
     * Handle drag enter event. Increase drag counter on dragEnter.
     */
    dragEnter() {
      this.dragCounter++;
    },

    /**
     * Handle drag leave event. Decrease drag counter on dragLeave.
     */
    dragLeave() {
      this.dragCounter--;
    },

    /**
     * Clear the file lists.
     * @param {boolean} emptyUpload - Indicates whether to clear upload list as well.
     */
    emptyFileLists(emptyUpload: boolean = true) {
      this.removeSelection(0, this.fileListEdit.length);
      this.fileListEdit.length = 0;
      if (emptyUpload) {
        this.fileListUpload.length = 0;
      }
      this.showDetail = false;
      this.initializeForResourceType();
    },

    /**
     * Add selected files to the fileListUpload list.
     * @param {ExtendedFile | null)[] | ExtendedFile | null} selectedFiles - Selected files.
     */
    fileListUploadSelected(
      selectedFiles: (ExtendedFile | null)[] | ExtendedFile | null,
    ) {
      if (selectedFiles === null) {
        return;
      }

      if (!Array.isArray(selectedFiles)) {
        selectedFiles = [selectedFiles];
      }
      this.emptyFileLists(false);

      // Pushing selected files into the upload list
      for (const file of selectedFiles) {
        const identifier = uuidv4();
        const version = +new Date();

        if (!file) {
          continue;
        }

        let $path = file.$path ? file.$path : "";
        if (!$path && file.webkitRelativePath) {
          $path = file.webkitRelativePath;
        }

        // Correctly determine the parentDirectory based on multiple inputs
        const parentDirectory = $path
          ? $path.substring(0, $path.lastIndexOf("/"))
          : file.path ?? "";

        // Correctly determine the path based on multiple inputs (check for .path or $path if .name still needs to be appended)
        let path = $path ?? file.path ?? "";
        if (!path.endsWith(file.name)) {
          path += file.name;
        }

        const fileInformation: FileInformation = {
          id: identifier,
          path: this.dirTrail + path,
          parentDirectory: this.dirTrail + parentDirectory,
          type: "Leaf",
          uploading: false,
          info: file,
          name: file.name,
          size: file.size,
          versions: [version],
          latestVersion: version,
          currentVersion: version,
          lastModified: `${file.lastModified}`,
          metadata: { [version]: factory.dataset() as unknown as Dataset },
        };

        // Prevent duplicates
        if (
          !this.fileListUpload.some(
            (entry) => entry.path === fileInformation.path,
          )
        ) {
          this.fileListUpload.push(fileInformation);
        }
      }

      // Clear selection in files view table
      const table = (this.$refs.filesView as Vue).$refs
        .adaptTable as unknown as AdaptTable;
      table.clearSelected();

      // Clear form-file inputs
      (this.$refs.fileTrigger as typeof BFormFile).reset();
      (this.$refs.folderTrigger as typeof BFormFile).reset();

      this.showDetail = false;
    },

    /**
     * Initialize the file based on resource type.
     */
    initializeForResourceType() {
      if (
        this.resourceTypeInformation?.resourceContent?.metadataView
          ?.editableDataUrl
      ) {
        const identifier = uuidv4();
        const version = +new Date();
        this.fileListUpload.push({
          id: identifier,
          path: "",
          uploading: false,
          name: "",
          parentDirectory: this.dirTrail,
          type: "Leaf",
          size: 0,
          versions: [version],
          latestVersion: version,
          currentVersion: version,
          metadata: { [version]: factory.dataset() as unknown as Dataset },
          dataUrl: "",
        } satisfies FileInformation);
      }
    },

    /**
     * Handle file drop action for upload.
     * @param {DragEvent} ev - Drag event.
     */
    async uploadDrop(ev: DragEvent) {
      if (this.fileAddable) {
        this.dragCounter = 0;

        // Handling file drops
        if (ev?.dataTransfer?.items) {
          const files = await FileUtil.getFilesDataTransferItems(
            ev.dataTransfer.items,
          );
          for (const file of files) {
            this.fileListUploadSelected(file);
          }
        }
      }
    },

    /**
     * Update the detail visibility.
     *
     * @param {boolean} visibility - New visibility state.
     */
    setShowDetail(visibility: boolean) {
      this.showDetail = visibility;
    },

    /**
     * Update the state indicating if the system is waiting for a response.
     *
     * @param {boolean} waiting - Whether the system is waiting for a response or not.
     */
    setWaitingForResponse(waiting: boolean) {
      this.isWaitingForResponse = waiting;
    },

    /**
     * Update the uploading state.
     *
     * @param {boolean} uploading - Indicates if a file is currently uploading.
     */
    setIsUploading(uploading: boolean) {
      this.isUploading = uploading;
    },

    /**
     * Updates the current folder's content.
     *
     * @param {FolderContent[]} folderContent - Information about the items in the folder.
     */
    updateFolderContent(folderContent: FolderContent[]) {
      this.folderContents = folderContent;
    },

    /**
     * Updates the list of files being edited.
     *
     * @param {FolderContent[]} fileList - New list of files for editing.
     */
    updateEditFileList(fileList: FolderContent[]) {
      this.fileListEdit = fileList;
    },

    /**
     * Deletes files from the upload list.
     *
     * @param {number} startIndex - Where to start the deletion in the list.
     * @param {number} numberOfFiles - How many files to delete from the list.
     */
    deleteFromUploadList(startIndex: number, numberOfFiles: number) {
      this.fileListUpload.splice(startIndex, numberOfFiles);
    },

    /**
     * Remove selected items from the list.
     * @param {number} index - Start index.
     * @param {number} count - Number of items to remove.
     */
    removeSelection(index: number, count: number) {
      const selectionRemovable: FolderContent[] = this.fileListEdit.splice(
        index,
        count,
      );

      const selectedItems = (this.$refs.filesView as typeof FilesView)
        .selectedItems as FolderContent[];
      let toRemove: number[] = [];

      // Unselecting rows in table
      for (let i = 0; i < selectedItems.length; i++) {
        const item = selectedItems[i];
        const entry = selectionRemovable.find(
          (entry) => entry.name === item.name,
        );
        if (entry) {
          toRemove.push(i);
          // Update version info on update
          if (item.latestVersion < entry.latestVersion) {
            item.latestVersion = entry.latestVersion;
            item.currentVersion = entry.currentVersion;
            item.metadata[item.latestVersion] =
              entry.metadata[entry.latestVersion];
          }
        }
      }

      // Reverse to ensure removal works correctly
      toRemove = toRemove.reverse();
      for (const removeIndex of toRemove) {
        (
          (this.$refs.filesView as typeof FilesView)
            .selectedItems as FolderContent[]
        ).splice(removeIndex, 1);
      }
      (this.$refs.filesView as typeof FilesView).onSelection(
        (this.$refs.filesView as typeof FilesView).selectedItems,
      );
    },

    /**
     * Update the view mode based on the given fullscreen state.
     *
     * @param {boolean} activateFullscreen - Whether to activate the fullscreen mode.
     */
    updateViewMode(activateFullscreen: boolean) {
      this.isFullscreenActive = activateFullscreen;

      if (activateFullscreen) {
        document.body.classList.add("fullscreen-mode");
        this.mainStore.sidebarActive = false;
      } else {
        document.body.classList.remove("fullscreen-mode");
        this.isMetadataManagerHidden = true;
      }
    },

    /**
     * Toggle between fullscreen and regular mode.
     */
    toggleViewMode() {
      this.updateViewMode(!this.isFullscreenActive);
    },

    /**
     * Toggle the visibility of the metadata panel.
     */
    toggleMetadataPanel() {
      this.isMetadataManagerHidden = !this.isMetadataManagerHidden;
    },

    /**
     * Adjust view mode based on window width.
     */
    adjustViewForScreenWidth() {
      this.updateViewMode(document.documentElement.clientWidth < 1250);
    },
  },
});
</script>

<!-- FullScreen + Global Styles -->
<style>
body.fullscreen-mode #resourcecontentview {
  position: absolute;
  top: 110px;
  left: 50px;
  right: 0px;
  bottom: 0px;
  height: auto;
}
body.fullscreen-mode #resourcecontentview .DataSource .headerRow {
  margin-left: 0px;
  margin-right: 0px;
}
body.fullscreen-mode #metadataManagerDiv {
  position: fixed;
  bottom: 0px;
  top: 110px;
  right: 0px;
}
body.fullscreen-mode #metadataManagerDiv .card {
  border: 1px solid rgba(0, 0, 0, 0);
  height: 100%;
}
body.fullscreen-mode #metadataManagerDiv.hiddenMetadataManager {
  right: -600px !important;
}
body.fullscreen-mode #resourcecontentview #filesViewSpan {
  margin-right: 25px;
  right: 0px;
}
body.fullscreen-mode #toggleFullscreenButton {
  left: -68px;
  bottom: 4px;
}
body.fullscreen-mode .alert-warning {
  display: none;
}
#resourcecontentview #filesViewSpan,
body:not(.fullscreen-mode) #resourcecontentview #metadataManagerDiv,
#resourcecontentview .card,
#resourcecontentview .card-body {
  height: 100%;
}
#addColumnDropDown button {
  padding: 0;
  margin: 0;
}
#addColumnDropDown,
#addColumnDropDown__BV_toggle_,
#addColumnDropDown button {
  width: 30px;
  max-width: 30px;
}
#addColumnDropDown__BV_toggle_ {
  min-width: 30px;
}
#addColumnDropDown ul {
  padding-left: 10px;
}
#addColumnDropDown .custom-control {
  margin-right: 10px;
}
#metadataManagerDiv .input-group button {
  border-radius: 0px;
}
#metadataManagerDiv .input-group button:first-child {
  border-top-left-radius: 0.25rem;
  border-bottom-left-radius: 0.25rem;
}
#metadataManagerDiv .input-group button:last-child {
  border-top-right-radius: 0.25rem;
  border-bottom-right-radius: 0.25rem;
}
</style>

<style scoped>
#resourcecontentview :deep(input[type="file"]) {
  display: none;
  font-size: 0px;
  position: absolute;
  left: 0;
  top: 0;
  opacity: 0;
}
#resourcecontentview {
  position: relative;
  height: calc(100vh - 170px);
  margin-bottom: 20px;
}
#resourcecontentview :deep(#filesViewSpan) {
  position: absolute;
  right: 620px;
  left: 0px;
}
#metadataManagerDiv {
  position: absolute;
  right: 10px;
  width: 600px;
  top: 37px;
  -webkit-transition: all 0.3s linear;
  transition: all 0.3s linear;
}
#metadataManagerToggleFullscreen {
  margin-left: -32px;
  line-height: 11px;
  position: absolute;
  top: -3px;
  bottom: 0px;
  width: 2em;
  min-width: 2em;
  padding: 0px;
}
#metadataManagerToggleFullscreen :deep(span) {
  display: inline-block;
  transform: rotate(-90deg);
  -webkit-transform: rotate(-90deg);
  -moz-transform: rotate(-90deg);
  -ms-transform: rotate(-90deg);
  -o-transform: rotate(-90deg);
  white-space: nowrap;
  margin-left: -54px;
}
#toggleFullscreenButton {
  position: absolute;
  left: -44px;
  bottom: 4px;
  background-color: transparent;
  -webkit-transition: all 0.3s linear;
  -moz-transition: all 0.3s linear;
  -ms-transition: all 0.3s linear;
  -o-transition: all 0.3s linear;
  transition: all 0.3s linear;
}
#toggleFullscreenButton :deep(button) {
  padding: 3px;
  min-width: auto;
}
.droppable {
  cursor: pointer;
  position: fixed; /* Sit on top of the page content */
  width: 100%; /* Full width (cover the whole page) */
  height: 100%; /* Full height (cover the whole page) */
  top: 0;
  left: 0;
  right: 0;
  bottom: 0;
  background-color: rgba(0, 0, 0, 0.5); /* Black background with opacity */
  z-index: 1000; /* Specify a stack order in case you're using a different order for other elements */
  color: white;
  vertical-align: middle;
  text-align: center;
  font-size: 42pt;
}
.droppableText {
  margin-top: 9em;
  margin-left: 4em;
}
#resourcecontentview :deep(.card-body) {
  padding-top: 8px;
  padding-bottom: 8px;
  padding-left: 0px;
  padding-right: 0px;
}
</style>
